#version 430

layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

in vec2 teUV[3];
out vec2 gUV;

in vec3 teCamPosition[3];
out vec3 gCamPosition;

in vec3 teCamNormal[3];
out vec3 gCamNormal;

out vec3 gTriDistance;

in vec3 tePatchDistance[3];
out vec3 gPatchDistance;

void main(void)
{
    // passthrough geometry shader for wireframe rendering
    // just addind TriDistance;

    gTriDistance = vec3(1, 0, 0);
    gUV = teUV[0];
    gCamPosition = teCamPosition[0];
    gCamNormal = teCamNormal[0];
    gPatchDistance = tePatchDistance[0];
    gl_Position = gl_in[0].gl_Position;
    EmitVertex();

    gTriDistance = vec3(0, 1, 0);
    gUV = teUV[1];
    gCamPosition = teCamPosition[1];
    gCamNormal = teCamNormal[1];
    gPatchDistance = tePatchDistance[1];
    gl_Position = gl_in[1].gl_Position;
    EmitVertex();

    gTriDistance = vec3(0, 0, 1);
    gUV = teUV[2];
    gCamPosition = teCamPosition[2];
    gCamNormal = teCamNormal[2];
    gPatchDistance = tePatchDistance[2];
    gl_Position = gl_in[2].gl_Position;
    EmitVertex();

    EndPrimitive();

}
